*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\RULER\HRULER.PRG
*+
*+    Copyright(C) 1983-2013 by Auge & Ohr
*+
*+    Functions: Function MAIN()
*+               Procedure DoInit()
*+               Procedure Proc_ON_PAINT()
*+
*+    Reformatted by Click! 2.05.18 on Jan-10-2020 at  9:32 am
*+
*+--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////
//
//  hruler.prg
//
//  Contents:
//      Draws a horizontal ruler marked every 5 pixels on the screen
//      Units are Top-Down Library columns
//      Black line at each column, blue line at midcolumn
//
//////////////////////////////////////////////////////////////////////

#include "hmg.ch"

*+--------------------------------------------------------------------
*+
*+    Function MAIN()
*+
*+--------------------------------------------------------------------
*+
FUNCTION MAIN

   DEFINE WINDOW Win1 ;
           AT 0, 0 ;
           WIDTH 1280 ;
           HEIGHT 100 ;
           TITLE "Ruler" ;
           ICON ".\RES\HPRULER.ico" ;
           MAIN ;
           NOMAXIMIZE ;
           NOSIZE ;
           ON INIT DoInit() ;
           ON PAINT Proc_ON_PAINT()

   //         DEFINE MAIN MENU
   //             DEFINE POPUP "File"
   //                 MENUITEM "Exit" ACTION Win1.Release
   //             END POPUP
   //         END MENU

   //         DEFINE STATUSBAR
   //             DATE
   //             CLOCK
   //         END STATUSBAR

   END WINDOW

   CENTER WINDOW Win1
   ACTIVATE WINDOW Win1

RETURN Nil

*+--------------------------------------------------------------------
*+
*+    Procedure DoInit()
*+
*+    Called from ( hruler.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE DoInit()

   ThisWindow.AlphaBlendTransparent := 200
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Proc_ON_PAINT()
*+
*+    Called from ( hruler.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Proc_ON_PAINT

LOCAL Width  := BT_ClientAreaWidth( "Win1" )
LOCAL Height := BT_ClientAreaHeight( "Win1" ) - BT_StatusBarHeight( "Win1" )
LOCAL hDC, BTstruct
LOCAL cText
LOCAL i

   hDC = BT_CreateDC( "Win1", BT_HDC_INVALIDCLIENTAREA, @BTstruct )

   FOR i := 0 TO Width STEP 10
      IF ( i % 100 ) = 0
         BT_DrawLine( hDC, 100 - 30, i, 35, i, BLACK, 2 )

         cText := LTRIM( STR( i ) )
         nTypeText := BT_TEXT_TRANSPARENT                   // BT_TEXT_OPAQUE
         nAlingText := BT_TEXT_CENTER + BT_TEXT_TOP
         BT_DrawText( hDC, 10, i, cText, "MS Sans Serif", 10, BLUE, { 228, 228, 228 }, nTypeText, nAlingText )

      ELSEIF ( i % 50 ) = 0
         BT_DrawLine( hDC, 100 - 30, i, 50, i, BLACK, 2 )
      ELSE
         BT_DrawLine( hDC, 100 - 30, i, 60, i, BLACK, 2 )
      ENDIF
   NEXT

   BT_DeleteDC( BTstruct )
   RETURN

/*
#define YELLOW  { 255,  255,    0 }
#define PINK    { 255,  128,  192 }
#define RED     { 255,    0,    0 }
#define FUCHSIA { 255,    0,  255 }
#define BROWN   { 128,   64,   64 }
#define ORANGE  { 255,  128,   64 }
#define GREEN   {   0,  255,    0 }
#define PURPLE  { 128,    0,  128 }
#define BLACK   {   0,    0,    0 }
#define WHITE   { 255,  255,  255 }
#define GRAY    { 128,  128,  128 }
#define BLUE    {   0,    0,  255 }
*/

*+ EOF: HRULER.PRG